#include "HelloWorldScene.h"

CCScene* HelloWorld::scene()
{
   CCScene *scene = CCScene::node();
   HelloWorld *layer = HelloWorld::node();
   scene->addChild(layer);
   return scene;
}

/* ʱȭ ϴ Լ   */
bool HelloWorld::init()
{
	if ( !CCLayer::init() )
      return false;
	
	//	 ȭ â ũ⸦ Ѵ.
	CCSize size = CCDirector::sharedDirector()->getWinSize();
	m_fMissile_Speed = 60.f;		//	̻ ӵ
    m_Missile_Vec = ccp(0, 0);		//	̻ ̵  

	m_pTarget = new CCSprite;
    m_pTarget->initWithFile("target.png");

    //	Ÿ ġ  ȭ â ߾ӿ ġ.
    m_pTarget->setPosition(ccp(size.width / 2, size.height / 2));
    this->addChild(m_pTarget);
	
	m_pMissile = new CCSprite;
    m_pMissile->initWithFile("Missile.png");
    m_pMissile->setPosition(ccp(0, 0));
    this->addChild(m_pMissile);

	this->SetMissileVector();		//	̻ ̵  ͸ Ѵ.

	m_bIsAttacked = false;			//	浹ϸ true ȴ.
    m_fPullPower = 200.f;			//	и 
	m_Attacked_Vec = ccp( 0, 0 );	//	Ÿ ̻ϰ 浹 , з 
	m_fResist = 200.f;				//	и  
	m_fTarget_Speed = 300.f;		//	Ÿ ̵ ӵ

	this->schedule(schedule_selector(HelloWorld::Update));

    return true;
}

/* ֱ ȣǴ Լ   */
void HelloWorld::Update(float dt)
{
    this->MissileAction(dt);	//	̻ ̵  ȸ
   
    this->SetMissileVector();	//	̻ ̵   ϱ
	
	this->CheckCollision();		//	̻ϰ Ÿ  浹 üũ Ȯ
    
	this->TargetAction(dt);		//	̻ϰ Ÿ 浹 üũ η Ÿ ̵

	this->DynamicMoving(dt);	//	̻ ̳ ̵
}

/*	̻ ̵ ȸ ϴ Լ	*/
void HelloWorld::MissileAction(float dt)
{
	CCPoint pos = m_pMissile->getPosition();

    /*
		̻ ̵ Ű κ
		̻ ̵    ̵ Ű ȴ. 
		̵  Ϳ    ؼ ̻ ġ Ѵ.
    */
    pos.x += m_fMissile_Speed * m_Missile_Vec.x * dt;
    pos.y += m_fMissile_Speed * m_Missile_Vec.y * dt;
	
	m_pMissile->setPosition(pos);
	
	/*
		̻ ȸϴ κ
		̵  ͸ ؼ  Ѵ.
	*/ 
    float rad = atan2(m_Missile_Vec.x, m_Missile_Vec.y); 
    float Angle = rad * 180.f / 3.14;

    m_pMissile->setRotation(Angle);
}

/*	̻ ̵   ϴ Լ	*/
void HelloWorld::SetMissileVector()
{
	//	̻ϰ Ÿ ġ Ѵ.
	CCPoint TarPos = m_pTarget->getPosition();
    CCPoint Missile_pos = m_pMissile->getPosition();

    // ̵   ϱ
    m_Missile_Vec.x = TarPos.x - Missile_pos.x;            
    m_Missile_Vec.y = TarPos.y - Missile_pos.y;            
	
	//	̵   ȭ ,  Ʈ Ÿ Ѵ.
    m_fDis = sqrtf(m_Missile_Vec.x * m_Missile_Vec.x + 
		m_Missile_Vec.y * m_Missile_Vec.y);
	
	// ̵  ͸ ȭ Ѵ.
    m_Missile_Vec.x /= m_fDis;         
    m_Missile_Vec.y /= m_fDis;
}

/*	
	̻ϰ Ÿٰ 浹 θ Ȯؼ 
	浹  ̻ ݴ  Ÿ ̵Ű Լ
*/
void HelloWorld::TargetAction(float dt)
{
	CCPoint pos = m_pTarget->getPosition();
    
	//	   
	if(!m_bIsAttacked)
	{   
		if (GetAsyncKeyState(VK_RIGHT))
			pos.x += m_fTarget_Speed * dt;
		if (GetAsyncKeyState(VK_LEFT))
			pos.x -= m_fTarget_Speed * dt;
		if (GetAsyncKeyState(VK_DOWN))
			pos.y -= m_fTarget_Speed * dt;
		if (GetAsyncKeyState(VK_UP))
			pos.y += m_fTarget_Speed * dt;
    }

	//	   
	else
	{
		/*
			̻   ǥ ؼ ڷ и ȿ
		*/
		pos.x += m_fPullPower * m_Attacked_Vec.x * dt;
		pos.y += m_fPullPower * m_Attacked_Vec.y * dt;
		
		//	и  
		m_fPullPower -= m_fResist * dt;
		
		//	浹 , ʱ ·  
		if(m_fPullPower < 0)
		{
			m_fPullPower = 200;		//	и  ٽ ʱġ 
			m_bIsAttacked = false;	//	浹 θ false ʱ 
		}
	}
	
	//	Ʈ  ǥ 
	m_pTarget->setPosition(pos);
}

/*	
	̻ϰ Ÿٰ 浹 üũ Ȯϴ Լ 
	̴ Ÿ ǴѴ.
*/
void HelloWorld::CheckCollision()
{
	//	̻ϰ Ÿ ġ Ѵ.
	CCPoint TarPos = m_pTarget->getPosition();
    CCPoint Missile_pos = m_pMissile->getPosition();
	
	float width = TarPos.x - Missile_pos.x; 
	float height = TarPos.y - Missile_pos.y; 
	
	float dis = sqrtf( width * width + height * height );

	// 浹 ó ( ̻ϰ Ÿ   Ÿ ̳  浹  )
	if ( dis < 70 )
	{   
		//	浹  ̻  ͸ .
		m_Attacked_Vec = m_Missile_Vec;
		
		m_bIsAttacked = true;				//	浹  true 

		m_pMissile->setPosition(ccp(0, 0));	//	̻ ڸ ̵
   }
}

/*	̻ ̳ ̵ óϴ Լ	*/
void HelloWorld::DynamicMoving(float dt)
{
	//	̻ ġ 
	CCPoint MissilePos = m_pMissile->getPosition();
	
	//	 ͼ  ȯ
	float theta = m_pMissile->getRotation() *  3.14f / 180.f; 
	
	//	  ̵ų  ũ()
	float scala = m_fMissile_Speed * 0.45f * dt;

	/*
		MissilePos.x += scala * fabs(cos(theta));
		MissilePos.y += scala * fabs(sin(theta));
	*/
	MissilePos.x += scala * cos(theta);
	MissilePos.y += scala * sin(theta);

	m_pMissile->setPosition(MissilePos);
}
